#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <pcap.h>

#include <vector>

#include "util.h"

#define DHT_ID_SIZE 4

using namespace std;

/*
template<typename T>
class MyAllocator {
public:

    typedef T value_type;
    typedef value_type* pointer;
    typedef const value_type* const_pointer;
    typedef value_type& reference;
    typedef const value_type& const_reference;
    typedef std::size_t size_type;
    typedef std::ptrdiff_t difference_type;

	pointer allocate(size_type numObiects, const void *localityHint = 0)
	{
		return (pointer)malloc(numObiects * sizeof(T));
	}

	void deallocate(pointer ptrToMemory, size_type numObjects)
	{
		free(ptrToMemory);
	} 
	inline void construct(pointer p, const T& t) { new(p) T(t); }
	inline void destroy(pointer p) { p->~T(); }
};
*/

template<typename T>
class MyAllocator {
public : 
    //    typedefs

    typedef T value_type;
    typedef value_type* pointer;
    typedef const value_type* const_pointer;
    typedef value_type& reference;
    typedef const value_type& const_reference;
    typedef std::size_t size_type;
    typedef std::ptrdiff_t difference_type;

public : 
    //    convert an allocator<T> to allocator<U>

    template<typename U>
    struct rebind {
        typedef MyAllocator<U> other;
    };

public : 
    inline explicit MyAllocator() {}
    inline ~MyAllocator() {}
    inline explicit MyAllocator(MyAllocator const&) {}
    template<typename U>
    inline explicit MyAllocator(MyAllocator<U> const&) {}

    //    address

    inline pointer address(reference r) { return &r; }
    inline const_pointer address(const_reference r) { return &r; }

    //    memory allocation

    inline pointer allocate(size_type cnt, 
       typename std::allocator<void>::const_pointer = 0) { 
      return reinterpret_cast<pointer>(::operator new(cnt * sizeof (T))); 
    }
    inline void deallocate(pointer p, size_type) { 
        ::operator delete(p); 
    }

    //    size

    inline size_type max_size() const { 
        return std::numeric_limits<size_type>::max() / sizeof(T);
 }

    //    construction/destruction

    inline void construct(pointer p, const T& t) { new(p) T(t); }
    inline void destroy(pointer p) { p->~T(); }

    inline bool operator==(Allocator const&) { return true; }
    inline bool operator!=(Allocator const& a) { return !operator==(a); }
};    //    end of class Allocator 

typedef vector<char,MyAllocator<char>> CharVect;

extern "C"
CharVect Return_ID(char *pkt, int pkt_len)
{

	//CharVect *pcv = new CharVect;
	//CharVect &cv = *pcv;

	CharVect cv;
	
	//cout << "In Return_ID" << endl;
	
	struct ip *iph = (struct ip*) pkt;
	char *payload = ip_payload(iph);
	
	if(!payload) {		// Neither TCP nor UDP
		return cv;
	}

	//char hexstr[DHT_ID_SIZE*2+1];
	//hexstr[2*DHT_ID_SIZE] = '\0';
	//for(int i=0;i<DHT_ID_SIZE;i++){
	//	sprintf(hexstr+2*i,"%.2x.", (unsigned char)payload[i]);
	//}

	//return chars_to_charvect(hexstr);

	//cout << "2"<< endl;
	for(int i=0;i<DHT_ID_SIZE;i++){
		cv.push_back(payload[i]);			
	}
	
	return cv;
}

