#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <pcap.h>
#include <iostream>
#include <sstream>
#include <string>
#include <map>
#include <list>
#include <vector>
#include <algorithm>
#include <ext/hash_map>
#include <ext/hash_set>



using namespace std;
using namespace __gnu_cxx;

#define PORTSIZE	10
#define TIMEOUT		100
#define TIME_THRESHOLD 5  // In secs
#define TIME_PKTBUFFER 2  // Time for which pkt buffer are kept in the list In secs




struct miphdr {
#if __BYTE_ORDER == __LITTLE_ENDIAN
	unsigned int ihl:4;
	unsigned int version:4;
#elif __BYTE_ORDER == __BIG_ENDIAN
	unsigned int version:4;
	unsigned int ihl:4;
#else
# error	"Please fix <bits/endian.h>"
#endif
	u_int8_t tos;
	u_int16_t tot_len;
	u_int16_t id;
	u_int16_t frag_off;
	u_int8_t ttl;
	u_int8_t protocol;
	u_int16_t check;
	u_int32_t saddr;
	u_int32_t daddr;
	/*The options start here. */
};

struct mudphdr {
	u_int16_t source;
	u_int16_t dest;
	u_int16_t len;
	u_int16_t check;
};

struct mtcphdr {
	u_int16_t source;
	u_int16_t dest;
	u_int32_t seq;
	u_int32_t ack_seq;
#  if __BYTE_ORDER == __LITTLE_ENDIAN
	u_int16_t res1:4;
	u_int16_t doff:4;
	u_int16_t fin:1;
	u_int16_t syn:1;
	u_int16_t rst:1;
	u_int16_t psh:1;
	u_int16_t ack:1;
	u_int16_t urg:1;
	u_int16_t res2:2;
#  elif __BYTE_ORDER == __BIG_ENDIAN
	u_int16_t doff:4;
	u_int16_t res1:4;
	u_int16_t res2:2;
	u_int16_t urg:1;
	u_int16_t ack:1;
	u_int16_t psh:1;
	u_int16_t rst:1;
	u_int16_t syn:1;
	u_int16_t fin:1;
#  else
#   error "Adjust your <bits/endian.h> defines"
#  endif
	u_int16_t window;
	u_int16_t check;
	u_int16_t urg_ptr;
};

#define ICMP_ECHO 	8
struct micmphdr {
	u_int8_t type;		/* message type */
	u_int8_t code;		/* type sub-code */
	u_int16_t checksum;
	union {
		struct {
			u_int16_t id;
			u_int16_t sequence;
		} echo;		/* echo datagram */
		u_int32_t gateway;	/* gateway address */
		struct {
			u_int16_t __unused;
			u_int16_t mtu;
		} frag;		/* path mtu discovery */
	} un;
};


struct connid {
	unsigned int sip;
	unsigned int dip;
	unsigned short sp;
	unsigned short dp;

	bool operator<(const struct connid cid) const {
		if (sip < cid.sip)
			return true;
		if (sip > cid.sip)
			return false;
		if (dip < cid.dip)
			return true;
		if (dip > cid.dip)
			return false;
		if (sp < cid.sp)
			return true;
		if (sp > cid.sp)
			return false;
		if (dp < cid.dp)
			return true;
		return false;
}};

typedef struct connid connid_t;

typedef struct connrec {
	unsigned int sip;
	unsigned int dip;
	unsigned short sp;
	unsigned short dp;
	unsigned int secs;
	unsigned int usecs;
	unsigned short id;
} connrec_t;

typedef struct conntime {
	struct timeval f;
	struct timeval l;
	unsigned short id;
} conntime_t;


void  make_ID(std::string& url);
void  testEncoding();

void printf_ip(unsigned int ip);
void str_ip(char *strip, int size, unsigned int ip);
bool lesstime(const connrec_t & cr1, const connrec_t & cr2);
int pcap_hdr_size(pcap_t * pkt_d);
void make_dump_filename(char *fname, int size, const char *prefix, const char *dport);
void postprocess_dump_file(const char *cmd, const char *filename);
void ip_string(std::string &strip, unsigned int ip);






