#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <pcap.h>
#include <iostream>
#include <sstream>
#include <string>
#include <map>
#include <list>
#include <vector>
#include <algorithm>
#include <ext/hash_map>
#include <ext/hash_set>
#include <regex.h>

//#include "handle_pcap.h"

using namespace std;
using namespace __gnu_cxx;
typedef vector<char> CharVect;

class Message
{
public:
	int32_t id;		// An ID to differenciate the message to others by content. May use checksum

	struct timeval tv;
	double ts;

	char *pkt;
	int pkt_len;

	bool operator==(const Message &other) const 
	{
		if( id != other.id )
			return false;

		if(pkt_len != other.pkt_len)
			return false;

		for(int i=pkt_len-1; i>=0; i--)	// Compare from the last byte of the packets
			if(pkt[i] != other.pkt[i])
				return false;

		return true;
	}
};


/** BEGIN FIX **/
namespace __gnu_cxx                                                                                 
{                                                                                             
	template<> struct hash<CharVect>                                                       
	{                                                                                           
		size_t operator()( const CharVect& x ) const                                           
		{                                                  
			char *data = new char[x.size()];			
			size_t value = hash< const char* >()( data );                                              
			delete data;
			return value;
		}                                                                                         
	};

	template<> struct hash<const Message *>
	{                                                                                           
		size_t operator()( Message* const &x ) const                                           
		{
			cout << "called" << endl;
			return hash< int >()( x->id );                                              
		}  
	};
}

struct EqPMessage
{
	bool operator()(const Message* m1, const Message* m2) const
	{
		cout << "called 2" << endl;
		return (*m1 == *m2);
	}
};

typedef hash_set<Message*, hash<const Message*>, EqPMessage> PMessageSet;

int main(int argc, char* argv[])
{
	// Reglar expression test
	regex_t reg;
	int ret = regcomp(&reg, "PRIVMSG\\s+(\\w+)", REG_EXTENDED || REG_ICASE);
	
	if(ret == 0) {
		size_t nmatch = 3;
		regmatch_t pmatch[3];
		ret = regexec(&reg, "Test PRIVMSG hello", nmatch, pmatch, 0);
		if(ret == 0) {
			cout << nmatch << " " << pmatch[2].rm_so << " " <<pmatch[2].rm_eo <<  endl;
		}
		else {
			cout << "No match " << REG_NOMATCH << " " << ret << endl;
		}
	}
	return 0;

	hash_map<CharVect, int>  map;
	hash_map<CharVect, int>::iterator iter;
	
	CharVect cv, cv2;
	cv.push_back('a');
	cv2.push_back('b');
	
	map[cv] = 10;

	for(iter = map.begin(); iter != map.end(); iter++) {
		printf("%d\n", iter->second);
	}

	printf("%d\n", map[cv2]);

	PMessageSet msg_set_;
	PMessageSet::iterator hiter;
	Message m1, m2;

	char *c1 = "abcd";
	char *c2 = "abcd";	

	m1.pkt = c1;
	m1.pkt_len =4;
	m1.id = 1;
	m2.pkt = c2;
	m2.pkt_len =4;	
	m2.id = 1;

	msg_set_.insert(&m1);
	hiter = msg_set_.find(&m2);
	if( hiter != msg_set_.end() ) {
		cout << "present" << endl;
	}
	else {
		cout << "no" << endl;
	}

	msg_set_.erase( &m2);
	hiter = msg_set_.find(&m2);
	if( hiter != msg_set_.end() ) {
		cout << "present" << endl;
	}
	else {
		cout << "no" << endl;
	}
		
	return 0;
}

