#ifndef __UTIL_H__
#define __UTIL_H__

#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <pcap.h>
#include <iostream>
#include <sstream>
#include <string>
#include <map>
#include <list>
#include <vector>
#include <algorithm>
#include <ext/hash_map>
#include <ext/hash_set>

using namespace std;

struct timeval time_difference(const struct timeval &first, const struct timeval &second);
double time_minus(const struct timeval &first, const struct timeval &second);
double time_to_double(const struct timeval &tv);

string charvect_to_string(const vector<char> &v);
string charvect_to_hexstring(const vector<char> &v);	// To print the unreadable chars
string charvect_to_read_string(const vector<char> &v);
vector<char> chars_to_charvect(char *chars);
vector<char> string_to_charvect(string &s);
vector<char> nchars_to_charvect(char *chars, int n);

char *ip_payload(struct ip *iph);
char *ip_payload(struct ip *iph, int iplen, int &payloadlen);

int hexfind(char *str, int len, const vector<char> &cv);

void push_vect_vector(vector<char> &vd, const vector<char> &vs);
void push_vect_string(vector<char> &v, string &s);
void push_vect_chars(vector<char> &v, const char *chars);
void push_vect_nchars(vector<char> &v, char *chars, int n);
void push_vect_int(vector<char> &v, int n);
void push_vect_int_reverse(vector<char> &v, int n);
void push_vect_short(vector<char> &v, short n);
vector<char> sock_vect(struct ip *iph);
vector<char> sock_vect_reverse(struct ip *iph);

int read_int_java(char *str);
short read_short_java(char *str);

#endif
