#include "coral_pkt_parser.h"

double getProcessingTimeDiff(struct timeval &r,struct timeval &s)
{
	long long int g = ((r.tv_sec*1000000+r.tv_usec) - (s.tv_sec*1000000 + s.tv_usec )) ;
	double offDouble = (double) g / 1000000.0 ; 
	return offDouble;
} 

bool checkThresTime(timeval* t1, timeval* t2, int time_thresh) 
{
	if (int(t1->tv_sec - t2->tv_sec) > time_thresh )
		return true;
	if (int(t1->tv_sec - t2->tv_sec) < time_thresh )
		return false;

	if ( t1->tv_usec < t2->tv_usec )
		return false;

	return true;
}


void  make_ID(std::string& url)
{	
  char key[url.size()+1];
  //const char *c_url = url.c_str();
  strcpy(key,url.c_str());
  printf("%s ",key);
  unsigned char hash[sha1::hashsize];
  //unsigned int hash[5];
  void *hid = static_cast<void *> (hash);
  bzero (hid, sha1::hashsize);
  sha1_hash (hid, key, strlen (key));
  
  for ( int i=0; i<sha1::hashsize; i++ )
    {	
      printf("%.2x",hash[i]);
      //printf("%.2X%c", hash[i], ((i+1) %16)? ' ' : '\n'); 
    }
  printf("\n");
	
}

void testEncoding()
{
	//const char key[] = "http://www.bbc.com/";
	//const char key[] = "165.124.182.74:5000";
	const char key[] = "128.112.139.80:5000";
	unsigned char hash[sha1::hashsize];
	//unsigned int hash[5];
	void *hid = static_cast<void *> (hash);
	bzero (hid, sha1::hashsize);
	sha1_hash (hid, key, strlen (key));
	
	for ( int i=0; i<sha1::hashsize; i++ )
	  { 
	printf("%.2x",hash[i]);
	//printf("%.2X%c", hash[i], ((i+1) %16)? ' ' : '\n'); 
	  }
	printf("\n");
	
	str id (strbuf ("%s", key));
	keyID hkey = makeID(id);
	strbuf s;
	s << hkey;
	warnx << s << "\n";
	warnx << id;
	printf("\n");
	unsigned long long int g = 1221374387*1000000; 
	double off = (double) g;
    printf("Size of long long types is %d bytes\n",(int)sizeof(long long));
	
    //printf("Signed long long min: %lld max: %lld\n",LLONG_MIN, LLONG_MAX);
    #if defined(_LONG_LONG)
	printf("YAHOO DEFINED\n");
	#else
	printf("NOT DEFINED LONG LONG\n");
	#endif
	
	printf("long int = %lld, double = %.6f \n",g,off);
	off  = (double) g/1000000.0;
	g = g - 129836;
	printf("long int = %lld, double = %.6f \n",g,off);
	g = g / 1000000;
	printf("long int = %lld, double = %.6f \n",g,off);
	return;

}


void printf_ip(unsigned int ip)
{
	ip = htonl(ip);
	printf("%d.%d.%d.%d", ip & 0xff, (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip >> 24) & 0xff);
}

void str_ip(char *strip, int size, unsigned int ip)
{
	bzero(strip, size);
	ip = htonl(ip);
	snprintf(strip, size, "%d.%d.%d.%d", ip & 0xff, (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip >> 24) & 0xff);
}

void ip_string(std::string &strip, unsigned int ip)
{
	ip = htonl(ip);
	int len = snprintf(NULL, 0,	"%d.%d.%d.%d", ip & 0xff, (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip >> 24) & 0xff);
	char charip[len+1];
	snprintf(charip,len+1,	"%d.%d.%d.%d", ip & 0xff, (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip >> 24) & 0xff);
	strip.assign(charip);
}


bool lesstime(const connrec_t & cr1, const connrec_t & cr2)
{
	if (cr1.secs < cr2.secs)
		return true;
	if (cr1.secs > cr2.secs)
		return false;
	if (cr1.usecs < cr2.usecs)
		return true;
	return false;
}

int pcap_hdr_size(pcap_t * pkt_d)
{
	int dl = pcap_datalink(pkt_d);
	int hdr_size = -1;

	switch (dl) {
	case DLT_NULL:
		hdr_size = 4;
		break;

	case DLT_EN10MB:
		hdr_size = 14;
		break;

	case DLT_FDDI:
		hdr_size = 13 + 8;	// fddi_header + LLC
		break;

	case DLT_RAW:
		hdr_size = 0;
		break;

	default:
		fprintf(stderr, "unknown data link type 0x%x", dl);
		break;
	}
	return hdr_size;
}

void make_dump_filename(char *fname, int size, const char *prefix, const char *dport)
{
	snprintf(fname, size, "%s-%s", prefix, dport);
}

/*
void postprocess_dump_file(const char *cmd, const char *filename)
{
	if (fork())
		return;
	if (setpriority(PRIO_PROCESS, 0, 10) == -1)
		perror("setpriority");
	if (execlp(cmd, cmd, filename, NULL) == -1)
		perror("execlp");
	exit(1);
}
*/


